## Comments, Questions, Feature Requests, Bug Reports

At this time, any kind of comment, question, feature request or bug report is welcome in the issue tracker.  If you are asking a question, please search the issues for an answer before making a post.

## Code Contributions

Community-driven development and enhancement of PowerModels is welcomed and encouraged. Please fell free to fork this repository and share your contributions to the master with a pull requests.

That said it is important to keep in mind the code-quality requirements and scope of PowerModels in mind, before preparing a contribution.

### PowerModels Scope
The primary motivation for PowerModels is to help researchers quickly and easily replicate _established_ results in power system optimization.
More preliminary research and development efforts are best left to other packages, which extend PowerModels.
That said, the PowerModels package should have a software design that makes building such extensions as easy as possible.

### Code Quality Requirements
PowerModels strives to be a user-friendly, highly-reliable, and well-maintained package.
To that end, the following code quality controls are necessary for all contributions,
- all features must have unit tests
- naming conventions must be consistent
- core features must have documentation
- code style must be consistent (e.g. 4 spaces for indentation)

Due to these quality control requirements, pull request to PowerModels may require lengthy discussion and code review (e.g. see [#111](https://github.com/lanl-ansi/PowerModels.jl/pull/111)).

PowerModels contributions that do not meet these scope or quality requirements are always welcome in [PowerModelsAnnex.jl](https://github.com/lanl-ansi/PowerModelsAnnex.jl)
